
import com.ibm.j2ca.base.SDOFactory;
import com.ibm.websphere.sca.Service;
import com.ibm.websphere.sca.ServiceManager;
import commonj.sdo.DataObject;

public class Component1Impl {
	/**
	 * Default constructor.
	 */
	public Component1Impl() {
		super();
	}

	/**
	 * Return a reference to the component service instance for this implementation
	 * class.  This method should be used when passing this service to a partner reference
	 * or if you want to invoke this component service asynchronously.    
	 *
	 * @generated (com.ibm.wbit.java)
	 */
	@SuppressWarnings("unused")
	private Object getMyService() {
		return (Object) ServiceManager.INSTANCE.locateService("self");
	}

	/**
	 * This method is used to locate the service for the reference
	 * named "CustomerInterfacePartner".  This will return an instance of 
	 * {@link com.ibm.websphere.sca.Service}.  This is the dynamic
	 * interface which is used to invoke operations on the reference service
	 * either synchronously or asynchronously.  You will need to pass the operation
	 * name in order to invoke an operation on the service.
	 *
	 * @generated (com.ibm.wbit.java)
	 *
	 * @return Service
	 */
	public Service locateService_CustomerInterfacePartner() {
		return (Service) ServiceManager.INSTANCE
				.locateService("CustomerInterfacePartner");
	}

	/**
	 * Method generated to support implemention of operation "start" defined for WSDL port type 
	 * named "TriggerInterface".
	 * 
	 * The presence of commonj.sdo.DataObject as the return type and/or as a parameter 
	 * type conveys that its a complex type. Please refer to the WSDL Definition for more information 
	 * on the type of input, output and fault(s).
	 */
	public void start(DataObject input1) {
		
		// Create CustomerBO
		String adapterNamespace = input1.getString("namespace");
		String objName = input1.getString("objectName");
		DataObject customerBO = null;
		try
		{
			customerBO = SDOFactory.createDataObject(adapterNamespace, objName);
		}
		catch(Exception ex)
		{
			System.out.println("Invalid value provided for Namespace and/or ObjectName: " + ex.getMessage());
			ex.printStackTrace();
		}
		if (customerBO != null)
		{
			DataObject customerBG = customerBO.getContainer();
			System.out.println(" *** Customer Object Initialized *** ");
			
			// Populate CustomerBO
			String operation = input1.getString("operation");
			if (operation.equalsIgnoreCase("create"))
			{
				customerBG.set("verb", operation);
			}
			if (operation.equalsIgnoreCase("update"))
			{
				customerBG.set("verb", operation);
			}
			if (operation.equalsIgnoreCase("delete"))
			{
				customerBG.set("verb", operation);
			}
			
			
			customerBO.set("pkey", input1.getString("pkey"));
			customerBO.set("fname", input1.getString("fname"));
			customerBO.set("lname", input1.get("lname"));
			customerBO.set("ccode", input1.get("ccode"));
			System.out.println(" *** Customer Object created *** ");		

			//Call the invoke method of Component2 and pass it the Customer object
			Service customerService = locateService_CustomerInterfacePartner();
			
			customerService.invoke("invoke", customerBG);
			
		}	
	}

}